package audiotesting;

import java.awt.Point;
import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;

/**
 *Clase encargada de ejecutar los envetos asociados al mouse en el panel de compuertas a la derecha
 */
public class MouseListener2 extends MouseAdapter{
    private SoundCircuit circuit;
    private SoundCircuit circuitbase;
    private Drawable currentComponent;
    private JPanel panel;
    private Point last, current;
    private Point point_panel1;

    public MouseListener2 (SoundCircuit b, SoundCircuit c, JPanel p){
        circuitbase = b;
        circuit = c;
        panel = p;
        last = current = null;
    }    
   
    public void mouseMoved(MouseEvent e) {
        last = e.getPoint();
        Drawable newComponent = circuit.find(last);
        if (newComponent == currentComponent) return;
        if (currentComponent != null) {
            currentComponent.setReleased();
            currentComponent = null;
        }
        if (newComponent != null) { 
            currentComponent = newComponent;
            currentComponent.setSelected();
        }
        panel.repaint();
    }
   
    public void mouseDragged(MouseEvent e) {
        point_panel1 = new Point(e.getX()+592,e.getY()-12);
    }
   
    public void mouseWheelMoved(MouseWheelEvent e) {
        if (currentComponent == null) return;
        currentComponent.flip();
        panel.repaint();
    }
   
    public void mouseReleased(MouseEvent e) {
        if (e.getX()<=0) {
        if (currentComponent instanceof GFiltroPasabajo )
            circuitbase.addFiltroPasabajo(point_panel1.getX(),point_panel1.getY());
       
        if (currentComponent instanceof GFiltroPasaalto )
            circuitbase.addFiltroPasaalto(point_panel1.getX(),point_panel1.getY()); 
       
        if (currentComponent instanceof GFiltroPasabanda )
            circuitbase.addFiltroPasabanda(point_panel1.getX(),point_panel1.getY());
       
        if (currentComponent instanceof GDelay )
            circuitbase.addDelay(point_panel1.getX(),point_panel1.getY());
       
        if (currentComponent instanceof GFlanger )
            circuitbase.addFlanger(point_panel1.getX(),point_panel1.getY());
       
        if (currentComponent instanceof GAudioSalida )
            circuitbase.addOutSound(point_panel1.getX()+15,point_panel1.getY()-15);
      
        if (currentComponent instanceof GAudioEntrada )
            circuitbase.addAudio(point_panel1.getX()+15,point_panel1.getY()-15);
        }
    
        if (currentComponent instanceof GWire )
            AudioTestingFrame.connection_state=1;
      }
     
}