package audiotesting;

import be.hogent.tarsos.dsp.AudioDispatcher;

interface OutSignal {
    /**
     * Metodo encargado de retornar el dispatcher
     * @return 
     */
    AudioDispatcher getDispatcher();
    /**
     * Metodo encargado de conectar la salida
     * @param drain 
     */
    void connectOutput(InSignal drain);
    /**
     * Metodo encargado de conectar la salida y asociarla a una Insignal
     * @param drain 
     */
    void connectDrain(InSignal drain);  
    /**
     * Metodo encargado de remover una sola entrada conectada a la salida
     * @param drain 
     */
    void removeFromDrains(InSignal drain);
    /**
     * Metodo encargado de remover todas coneccion
     */
    void disconnectAllOutput();
    /**
     * Meto encargado de retornar el nombre de la clase asociada y su id correspondiente
     * @return 
     */
    String getDescription();
}