package audiotesting;

import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.*;
import javax.swing.event.ChangeListener;

/**
 *Clase encargada de crear el panel asociado al efecto echo-delay
 */
public class PDelay extends JPanel{
    
    private Delay delayblock;
    static final int FPS_MIN = 0;
    static final int FPS_MAX = 30;
    static final int FPS_INIT = 15;
    private JLabel title;
    private JSlider decayslider;
    private JSlider echoslider;
    private JSlider gainslider;
    private JLabel decaylabel;
    private JLabel echolabel;
    private JLabel gainlabel;
    
    public PDelay(Delay delay_in){
        delayblock = delay_in;
        Dimension panelD = new Dimension(3*640/6,3*480/9); 
        setPreferredSize(panelD);
        decayslider = new JSlider(JSlider.HORIZONTAL,1, 100, 50);
        echoslider = new JSlider(JSlider.HORIZONTAL,1, 4000, 2000);
        gainslider = new JSlider(JSlider.HORIZONTAL,0, 200, 100);
        title = new JLabel("EFECTO DELAY", JLabel.CENTER);
        decaylabel = new JLabel("Decay", JLabel.CENTER);
        echolabel = new JLabel("Echo lengs (in ms)", JLabel.CENTER);
        gainlabel = new JLabel("Ganancia", JLabel.CENTER);
        
        //Listeners
        gainslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (delayblock != null) {
					double gainValue = gainslider.getValue() / 100.0;
					delayblock.setGain(gainValue);
				}
			}
		});
        echoslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (delayblock != null) {
					double echoValue = echoslider.getValue() / 1000.0;
					delayblock.setEchoLength(echoValue);
				}
			}
		});
        decayslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (delayblock != null) {
					double decayValue = decayslider.getValue() / 100.0;
					delayblock.setDecay(decayValue);
				}
			}
		});
        
     
        setLayout(new GridLayout(4,2));
        add(title);
        add(new JLabel("ID: #"+delayblock.getDescription().split("_")[1], JLabel.CENTER));
        add(decaylabel);
        Dimension d = decayslider.getPreferredSize();  
        decayslider.setPreferredSize(new Dimension(d.width-50,d.height));
        add(decayslider);
        add(echolabel);
        Dimension d1 = echoslider.getPreferredSize();  
        echoslider.setPreferredSize(new Dimension(d1.width-50,d.height));
        add(echoslider);
        add(gainlabel);
        Dimension d2 = gainslider.getPreferredSize();  
        gainslider.setPreferredSize(new Dimension(d2.width-50,d.height));
        add(gainslider);
    }
}
