package audiotesting;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.Hashtable;
import javax.swing.*;
import javax.swing.event.ChangeListener;
/**
 *Clase encargada de crear el panel asociado al Filtro Pasa Banda
 */
public class PPasabanda extends JPanel{
    
    private FiltroPasabanda Filterrblock;
    private JLabel title;
    private JSlider freqaltaslider;
    private JSlider freqbajaslider;
    private JLabel freqaltalabel;
    private JLabel freqbajalabel;
    
    public PPasabanda(FiltroPasabanda Filtro_in){
        Filterrblock = Filtro_in;
        Dimension panelD = new Dimension(3*640/6,3*480/9); 
        setPreferredSize(panelD);
        freqaltaslider = new JSlider(JSlider.HORIZONTAL,1, 12000, 4000);
        freqbajaslider = new JSlider(JSlider.HORIZONTAL,1, 12000, 500);
        title = new JLabel("FILTRO PASABANDA", JLabel.CENTER);
        freqaltalabel = new JLabel("Freq. Corte Sup.", JLabel.CENTER);
        freqbajalabel = new JLabel("Freq. Corte Inf.", JLabel.CENTER);
        Hashtable labelTable = new Hashtable();
        labelTable.put( new Integer( 0 ), new JLabel("Stop") );
        labelTable.put( new Integer( 12000 ), new JLabel("12000") );
        labelTable.put( new Integer( 1 ), new JLabel("1") );
        freqaltaslider.setLabelTable( labelTable );
        freqbajaslider.setLabelTable( labelTable );
        freqaltaslider.setMajorTickSpacing(1000);
        freqaltaslider.setPaintTicks(true);
        freqaltaslider.setPaintLabels(true);
        freqbajaslider.setMajorTickSpacing(1000);
        freqbajaslider.setPaintTicks(true);
        freqbajaslider.setPaintLabels(true);
        
        //Listeners
        freqaltaslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Filterrblock != null) {
					int freq = freqaltaslider.getValue();
					Filterrblock.setFreqAlta(freq);
				}
			}
		});
        freqbajaslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Filterrblock != null) {
					int freq = freqbajaslider.getValue();
					Filterrblock.setFreqBaja(freq);
				}
			}
		});
      
        setLayout(new GridLayout(3,2));
        add(title);
        add(new JLabel("ID: #"+Filterrblock.getDescription().split("_")[1], JLabel.CENTER));
        add(freqaltalabel);
        Dimension d3 = freqaltaslider.getPreferredSize();  
        freqaltaslider.setPreferredSize(new Dimension(d3.width-50,d3.height));
        add(freqaltaslider);
        add(freqbajalabel);
        Dimension d2 = freqbajaslider.getPreferredSize();  
        freqbajaslider.setPreferredSize(new Dimension(d2.width-50,d2.height));
        add(freqbajaslider);
    }
}
