package audiotesting;

import javax.swing.JPanel;

/**
 *Metodo encargado de manejar los paneles de contro asociado a los bloques del circuito
 */
public class PanelControl extends JPanel {
    
    private JPanel ActualPanel;
    private JPanel BlankPanel;
    
    /**
     * Constructor
     */
    public void PanelControl(){
        ActualPanel = null;
        BlankPanel = new JPanel();
        add(BlankPanel);
    }
    /**
     * Setea el panel sin nada
     */
    public void setBlankPanel(){
        removeAll();
        ActualPanel = BlankPanel;
        updateUI();
        repaint();
    }
    
    /**
     * Elige el panel actual
     * @param panel_in 
     */
    public void setPanel(JPanel panel_in){
        removeAll();
        ActualPanel = panel_in;
        add(ActualPanel);
    }
    
    /**
     * Retorna el panel actual
     * @return 
     */
    public JPanel getPanel (){
        return ActualPanel;
    }
    
    /**
     * Carga el panel actual
     */
    public void showActualPanel(){
        updateUI();
        repaint();
    }
    
}
